DOUBLE PRECISION FUNCTION ERR(errmax)
  use my_data
  IMPLICIT NONE
  INTEGER I
  DOUBLE PRECISION ONE,ZERO,TWO,TMP
  PARAMETER(TWO = 2.0D+0,ONE = 1.0D+0,ZERO = 0.0D+0)
  DOUBLE PRECISION errmax
  DOUBLE PRECISION DDOT
  EXTERNAL DDOT
  
  errmax = ZERO
  ERR = ZERO
  DO I = 1, nsv
     CALL AV(VK(:,I), WORK)
     CALL DAXPY(M, -BK(I,I), UK(1,I), 1, WORK,1)
     TMP = DDOT(M,WORK,1,WORK,1)

     CALL ATV(UK(:,I), WORK)
     CALL DAXPY(N, -BK(I,I), VK(1,I), 1, WORK,1)
     TMP = TMP + DDOT(N,WORK,1,WORK,1)

     TMP = SQRT(TMP/TWO)
     errmax = max(errmax,tmp)
     ERR = ERR + TMP / DBLE(nsv)
     print *,I,TMP
  ENDDO
  RETURN
END FUNCTION ERR
