SUBROUTINE CGS2(vntemp,V,k,j)
  use my_data
  IMPLICIT NONE
  INTEGER k,j
  DOUBLE PRECISION  ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0D+0, ZERO=0.0D+0,MINUSONE = -1.0D+0 )
  DOUBLE PRECISION V(k,j),vntemp(k)
  CALL DGEMV('T',k,j,ONE,V,k,vntemp,1,ZERO,WORK,1)
  CALL DGEMV('N',k,j,MINUSONE,V,k,WORK,1,ONE,vntemp,1)
  CALL DGEMV('T',k,j,ONE,V,k,vntemp,1,ZERO,WORK,1)
  CALL DGEMV('N',k,j,MINUSONE,V,k,WORK,1,ONE,vntemp,1)
END SUBROUTINE CGS2

SUBROUTINE MGS(V,WORK2)
  use my_data
  IMPLICIT NONE
  INTEGER I,J
  DOUBLE PRECISION ONE, ZERO, MINUSONE
  PARAMETER ( ONE = 1.0D+0, ZERO=0.0D+0,MINUSONE = -1.0D+0 )
  DOUBLE PRECISION ALPHA,V(ncv,nsv),DDOT,WORK2(nsv)

  DO I=1,nsv
     ALPHA = SQRT(DDOT(ncv,V(1,I),1,V(1,I),1))
     DO J=1,ncv
        V(J,I) = V(J,I)/ALPHA
     ENDDO

     IF (I .LT. nsv) THEN
        CALL DGEMV('T',ncv,nsv-I,ONE,V(1,I+1),ncv,V(1,I),1,ZERO,WORK2,1)
        CALL DGER(ncv,nsv-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),ncv)
        CALL DGEMV('T',ncv,nsv-I,ONE,V(1,I+1),ncv,V(1,I),1,ZERO,WORK2,1)
        CALL DGER(ncv,nsv-I,MINUSONE,V(1,I),1,WORK2,1,V(1,I+1),ncv)
     ENDIF
  ENDDO

END SUBROUTINE MGS
